// 
//  Copyright (C) 2002,2007,2008  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//

#ifndef PEGCMDBUTTONS_HH
#define PEGCMDBUTTONS_HH

#include <stdio.h>
#include <gtk/gtk.h>
#include <iostream>
#include <string>

using namespace std;


//---------------------------------------------------------------------------

class PegCmdButtons
{
public:

  PegCmdButtons();
  ~PegCmdButtons();

  void disableRunExitBtn()  
        { gtk_widget_set_sensitive(GTK_WIDGET(_runExitBtn), false); }
  void enableRunExitBtn()   
        { gtk_widget_set_sensitive(GTK_WIDGET(_runExitBtn), true); }
  void disableRunBtn()      
        { gtk_widget_set_sensitive(GTK_WIDGET(_runBtn), false); }
  void enableRunBtn()       
        { gtk_widget_set_sensitive(GTK_WIDGET(_runBtn), true); }
  void disableSaveBtn()     
        { gtk_widget_set_sensitive(GTK_WIDGET(_saveBtn), false); }
  void enableSaveBtn()      
        { gtk_widget_set_sensitive(GTK_WIDGET(_saveBtn), true); }
  void disablePunlearnBtn() 
        { gtk_widget_set_sensitive(GTK_WIDGET(_punlearnBtn), false); }
  void enablePunlearnBtn()  
        { gtk_widget_set_sensitive(GTK_WIDGET(_punlearnBtn), true); }
  void disableQuitBtn()     
        { gtk_widget_set_sensitive(GTK_WIDGET(_quitBtn), false); }
  void enableQuitBtn()      
        { gtk_widget_set_sensitive(GTK_WIDGET(_quitBtn), true); }
  void disableHelpBtn();     
  void enableHelpBtn();

  void setFileLabel(string fname); 
   
  string getCmdline();
  int   runCommand(); 
  void  punlearnCommand();
  int   save_file(string fname="", bool overwrite=true); 

  GtkWidget* base_widget() { return _layout; } 

private:
  
  GtkWidget*   _layout; 
  GtkWidget*   _toolbar; 
  GtkToolItem* _runExitBtn;
  GtkToolItem* _runBtn;
  GtkToolItem* _saveBtn;
  GtkToolItem* _punlearnBtn;
  GtkToolItem* _helpBtn;
  GtkToolItem* _quitBtn;
  GtkWidget*   _cmdline; 
  GtkWidget*   _fileLbl; 
  string       _label;

  static int RunExitCallback(GObject *object, gpointer user_data);
  static int RunCallback(GObject *object, gpointer user_data);
  static int SaveCallback(GObject *object, gpointer user_data);
  static int PunlearnCallback(GObject *object, gpointer user_data);
  static int HelpCallback(GObject *object, gpointer user_data);
  static int QuitCallback(GObject *object, gpointer user_data);
};

#endif
