// 
//  Copyright (C) 2008  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#include "PegPrintFileDialog.hh"
#include "PegApp.hh"
#include <iostream>
#include <unistd.h>

using namespace std;

PegPrintFileDialog::PegPrintFileDialog()
{
}

PegPrintFileDialog::~PegPrintFileDialog()
{
}

void PegPrintFileDialog::create_dialog()
{
   _dialog = gtk_dialog_new_with_buttons("Print File", NULL,
      GTK_DIALOG_DESTROY_WITH_PARENT, GTK_STOCK_OK, GTK_RESPONSE_OK,
      GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL, NULL);
   GtkWidget* tab = gtk_table_new(3,8, true);
   GtkWidget* lab_w = gtk_label_new("Printer Command:"); 
   gtk_container_add(GTK_CONTAINER(GTK_DIALOG(_dialog)->vbox), tab);
   _entry_w = gtk_entry_new(); 
   gtk_table_attach_defaults(GTK_TABLE(tab), lab_w, 1,3,1,2);
   gtk_table_attach_defaults(GTK_TABLE(tab), GTK_WIDGET(_entry_w), 3,7,1,2);
   show(); 
}

int PegPrintFileDialog::show()
{
   gtk_widget_show_all(_dialog);
   return 0;
}

int PegPrintFileDialog::doit()
{
   create_dialog();
   if (gtk_dialog_run(GTK_DIALOG(_dialog)) == GTK_RESPONSE_OK)
   {
      // perform print 
      print_file(); 
   }
   gtk_widget_destroy(_dialog);
   return 0; 
}


int PegPrintFileDialog::print_file()
{
   string txt = gtk_entry_get_text(GTK_ENTRY(_entry_w));
   string fname = theApp->get_file_path(); 

   if (fname.length() && (access(fname.c_str(),F_OK) == 0))
   {
      if (txt.length() == 0)
         _cmd = "lpr " + fname; 
      else
         _cmd = "cat " + fname + " | " + txt;
      theApp->status_message("Sending printer request to print file " + fname); 
      system(_cmd.c_str()); 
   }
   else 
   {
      string msg = "Error: Print request failed. Unable to access file " + fname; 
      theApp->status_message(msg); 
      return 1; 
   }
   return 0; 
}


