// 
//  Copyright (C) 2008  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#include "PegApp.hh"
#include "PegSaveAsDialog.hh"
#include "PegSaveChangesDialog.hh"

#include <fstream>
#include <iostream>

using namespace std;

PegSaveChangesDialog::PegSaveChangesDialog()
{
}

PegSaveChangesDialog::~PegSaveChangesDialog()
{
}

void PegSaveChangesDialog::generate_form()
{
   base_w = gtk_dialog_new_with_buttons("Modified File Confirmation",
                                         NULL,
	                                 GTK_DIALOG_DESTROY_WITH_PARENT,
	                                 GTK_STOCK_YES,
					 GTK_RESPONSE_ACCEPT,
	                                 GTK_STOCK_NO,
					 GTK_RESPONSE_REJECT,
					 GTK_STOCK_CANCEL,
					 GTK_RESPONSE_CANCEL,
					 NULL);
    tab_w = gtk_table_new(4,2, true);
    gtk_container_add(GTK_CONTAINER(GTK_DIALOG(base_w)->vbox), tab_w);
    lab_w = gtk_label_new("The file contents have been modified. \nSave changes before proceeding?");
    gtk_table_attach_defaults(GTK_TABLE(tab_w), lab_w, 0,2,1,3);

}

int PegSaveChangesDialog::show()
{
   gtk_widget_show_all(base_w);
   gtk_widget_show_all(tab_w);
   return 0;
}

int PegSaveChangesDialog::doit()
{
   generate_form();
   show(); 
   int rv, sts = gtk_dialog_run(GTK_DIALOG(base_w));
   string msg; 

   if (sts == GTK_RESPONSE_ACCEPT)
   {
      PegSaveAsDialog* dlg = new PegSaveAsDialog("");
      if (dlg)
      {
	 string dpth = dlg->get_default_path();
	 if (!dpth.length()) dlg->set_default_path(theApp->get_file_path());  
	 rv = dlg->doit();
	 delete dlg;
      }
   }
   else if (sts == GTK_RESPONSE_CANCEL)
      rv = 1; 
   else 
      rv = 0; 
   gtk_widget_destroy(base_w);
   return rv;
}

