// 
//  Copyright (C) 2008  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef PEGSPINADJUSTDIALOG_HH
#define PEGSPINADJUSTDIALOG_HH

#include <stdio.h>
#include <gtk/gtk.h>
#include <string>

using namespace std;

class PegSpinAdjustDialog
{
  public:
    PegSpinAdjustDialog(string name, GtkAdjustment* adj, int precis=0);
    virtual ~PegSpinAdjustDialog();
    virtual int show();

    int doit();

    int set_adjustscale_value(double val);
    int set_adjustspin_value(double val);

    void set_sensitive(); 

    static double adjustscale_value_callback(GObject *object, gpointer user_data);
    static double adjustspin_value_callback(GObject *object, gpointer user_data);

  protected:
    void create_dialog();
    
    GtkWidget* _dialog;
    GtkWidget* _adjustscale_w;
    GtkWidget* _adjustspin_w; 
    GtkWidget* _minlab; 
    GtkWidget* _maxlab; 

    double _adjustcurr; 
    double _adjustmin;
    double _adjustmax;

    string _name;
    GtkAdjustment* _adj; 
    int    _precis;        // number of digits after decimal

};

#endif 
