// 
//  Copyright (C) 2008  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef PRISMAPPENDCOLUMNCMD_HH
#define PRISMAPPENDCOLUMNCMD_HH

#include <stdio.h>
#include <gtk/gtk.h>
#include <string>

#include "PrismBaseObj.hh"
#include "PrismColumnInfraP.hh"

using namespace std;

class PrismDataTable;

class PrismAppendColumnCmd: public PrismBaseObj
{
  public:
    PrismAppendColumnCmd();
    ~PrismAppendColumnCmd();
    virtual int show();

    int doit(PrismDataTable* table); 

    void set_visible(); 

    static int toggled_value_callback(GObject *object, gpointer user_data);
    static int combobox_callback(GObject *object, gpointer user_data);
    static int check_callback(GObject *object, gpointer user_data);

  protected:
    void create_dialog();
    void validity_check(); 
    int  check_column_name(string proposed);
    
    PrismDataTable* _table;

    // column type frame 
    GtkWidget* _frame_w; 
    GtkWidget* _coltype_w;
    GtkWidget* _scalar_w;
    GtkWidget* _array_w;
    GtkWidget* _vector_w;

    // attributes frame 
    GtkWidget* _attframe_w; 
    GtkWidget* _atttable_w; 
    GtkWidget* _name_lw; 
    GtkWidget* _name_w;
    GtkWidget* _units_w;
    GtkWidget* _units_lw; 
    GtkWidget* _desc_w;
    GtkWidget* _desc_lw; 
    GtkWidget* _type_w;
    GtkWidget* _type_lw; 
    GtkWidget* _ssize_lw; 
    GtkWidget* _ssize_w; 
    GtkWidget* _asize_lw; 
    GtkWidget* _asize_w; 
    GtkWidget* _vdim_lw; 
    GtkWidget* _vdim_w; 
    GtkWidget* _vcomp_lw; 
    GtkWidget* _vcomp_w; 
    GtkWidget* _errtxt_lw; 
    GtkWidget* _defval_w; 
    GtkWidget* _defval_lw; 

    GdkColor   _errcolor;    // color structure for invalid backgrounds
    PrismColumnInfra_t _infra; 
    int   _dtype;            // data type  
    int   _ctype;            // column type  0 = scalar, 1 = array, 2 = vector
    int   _asize;            // array size
    int   _ssize;            // string length
    int   _vdim;             // vector dimension 
    int   _defsize;          // default values size 
    int     _colcnt;         // number of existing columns
    string* _colnames;       // existing column names
    string  _defval;         // initial value
};

#endif 
