// 
//  Copyright (C) 2008  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef PRISMHEADERDELETECMD_HH
#define PRISMHEADERDELETECMD_HH

#include <stdio.h>
#include <gtk/gtk.h>
#include <iostream>
#include <string>

#include "PrismBaseObj.hh"

using namespace std;

class PrismHeaderTable;

class PrismHeaderDeleteCmd: public PrismBaseObj
{
  public:
    PrismHeaderDeleteCmd();
    ~PrismHeaderDeleteCmd();
    virtual int show();

    int doit(PrismHeaderTable* table); 

    static void key_edited_callback(GObject *object, gpointer user_data);

    int validate_keyword(string keyname);

  protected:
    void create_dialog();
    
    PrismHeaderTable* _table;

    GtkWidget* _name_w;
    GtkWidget* _value_w;
    GtkWidget* _comment_w;

    string  _keyname;
    string  _value;
    string  _comment; 
};

#endif 
