// 
//  Copyright (C) 1998,2008  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//



#if !defined(_PRISMIPC_SERVER)
#define	_PRISMIPC_SERVER

#include "PrismIPCComm.hh"

// Forward declaration from Xm/Xm.h
typedef struct _XtAppStruct *XtAppContext;


//
// The Interprocess Communication Server Class
//

class PrismIPCServer : public PrismIPCComm 
{
	public:
		PrismIPCServer(char* pname, int initialize=1);
		PrismIPCServer(char* pname, XtAppContext, int initialize=1);
		virtual ~PrismIPCServer();

  		static	int   receiveCallback(void*, void*, char*, char*, int);
  		static	int   sendCallback(void*, void*, char*, char**, int*);

  		int		AddCallback(char *name,
					    PrismIPCMessage* (*appcb)(PrismIPCMessage&));

		void		SetAppContext( XtAppContext );

                static PrismIPCMessage* exitMsgCB( PrismIPCMessage& );

		virtual void    Exit() { exit(0); }

                void            InitializeServer(char* nam=NULL); 
                void        SetupServer(const char* classnam, const char* nam); 
                void            GtkLoopAdd();

	protected:

		virtual void		AppCmdOptions( PrismIPCMessage* ) {}
                PrismIPCMessage              *DoCallback(PrismIPCMessage&);
		static PrismIPCCallbackTablePtr     cbTable;

	private:
		void		Init();
		PrismIPCMessage*	CmdOptions();
                string          _accessName;
                int             _useDefaultName; // 1 = use default access name
                static int      _refcount;   
                static int      _initialized;   
};



#endif
