// 
//  Copyright (C) 2007-2008  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef PRISMMENU_HH
#define PRISMMENU_HH

#include <stdio.h>
#include <gtk/gtk.h>
#include <iostream>
#include <string>

#include "PrismBaseObj.hh"

using namespace std;

class PrismFileMenu;
class PrismEditMenu;
class PrismViewMenu;
class PrismHelpMenu;
class CiaoAnalysisMenu; 

class PrismMenu: public PrismBaseObj
{
  public:
    PrismMenu(string filename="", GtkTooltips* tips=NULL);
    ~PrismMenu();

    int update_filelist(string fname); 

    virtual int show(); 

  protected:
    PrismFileMenu  *menuFile;
    PrismEditMenu  *menuEdit;
    PrismViewMenu  *menuView;
    PrismHelpMenu  *menuHelp;
    CiaoAnalysisMenu *menuAnalysis; 
};

#endif 
