// 
//  Copyright (C) 2007-2008  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef PRISMUTILS_HH
#define PRISMUTILS_HH

#include <stdio.h>
#include <string>
#include <unistd.h>
#include <sys/stat.h>
#include "ascdm.h"

using namespace std;

extern int _string_to_double(string val, double &outv); 
extern int _string_to_float(string val, float &outv); 
extern int _string_to_long(string val, long &outv); 
extern int _string_to_ulong(string val, unsigned long &outv); 
extern int _string_to_short(string val, short &outv); 
extern int _string_to_ushort(string val, unsigned short &outv); 
extern int _string_to_bool(string val, bool &outv); 
extern int _string_to_dmdatatype(string val, dmDataType &outv);
extern int _dmdatatype_to_string(dmDataType val, string &outv);
extern int _strcmp_cis(const char* str1, const char* str2);
extern bool _file_writable(string fname);
extern int _file_copy(string infile, string outfile, 
                      mode_t mode=(S_IWUSR|S_IRUSR));
extern string _path_expand(string fname);
extern bool _file_executable(string fname);
extern bool _is_directory(string path); 
extern bool _valid_format(string val, int dtype); 

#endif 
