// 
//  Copyright (C) 2007-2008  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef PRISMVIZMENU_HH
#define PRISMVIZMENU_HH

#include <stdio.h>
#include <gtk/gtk.h>
#include <iostream>

#include "PrismBaseObj.hh"

using namespace std;

class PrismVizMenu: public PrismBaseObj 
{
  public:
    PrismVizMenu();
    virtual ~PrismVizMenu();

    static int inter_plot_cb();
    static int quick_plot_cb();
    static int print_plot_cb();
    static int inter_hist_cb();
    static int quick_hist_cb();
    static int print_hist_cb();
    static int image_cb();

    virtual int show();

  protected:
    GtkWidget *menu;
    GtkWidget *menuInterPlot;
    GtkWidget *menuQuickPlot;
    GtkWidget *menuPrintPlot;
    GtkWidget *menuInterHist;
    GtkWidget *menuQuickHist;
    GtkWidget *menuPrintHist;
    GtkWidget *menuImage;
};

#endif 
