// 
//  Copyright (C) 2002,2007,2008  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//

#ifndef TASKMONCMDBUTTONS_HH
#define TASKMONCMDBUTTONS_HH

#include <stdio.h>
#include <gtk/gtk.h>
#include <iostream>

class TaskmonFindDialog;
class TaskmonStatusArea;
class TaskmonPrintFileDialog;

using namespace std;


//---------------------------------------------------------------------------

class TaskmonCmdButtons
{
public:

  TaskmonCmdButtons();
  ~TaskmonCmdButtons();

  TaskmonStatusArea* status_area;
  TaskmonPrintFileDialog* _print_popup;
  TaskmonFindDialog* _find_dialog;

  GtkWidget* base_widget() { return _layout; } 

private:
  
  GtkWidget*   _layout; 
  GtkWidget*   _toolbar; 
  GtkToolItem* _FindBtn;
  GtkToolItem* _printBtn;
  GtkToolItem* _saveBtn;
  GtkToolItem* _quitBtn;

  static int FindCallback(GObject *object, gpointer user_data);
  static int PrintCallback(GObject *object, gpointer user_data);
  static int SaveAsCallback(GObject *object, gpointer user_data);
  static int QuitCallback(GObject *object, gpointer user_data);
};

#endif
