// 
//  Copyright (C) 2008  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef TASKMONPRINTFILEDIALOG_HH
#define TASKMONPRINTFILEDIALOG_HH

#include "TaskmonApp.hh"
#include "TaskmonTextArea.hh"
#include "TaskmonUtils.hh"
#include "TaskmonMessageDialog.hh"

#include <stdio.h>
#include <gtk/gtk.h>
#include <string>
#include <iostream>
#include <fstream>

using namespace std;

class TaskmonPrintFileDialog
{
  public:
    TaskmonPrintFileDialog();
    ~TaskmonPrintFileDialog();

  int doit();
    int _gather_info();
  int print_file();

  protected:

    static int PopupOkCB(GObject *object, gpointer user_data);
    static int PopupApplyCB(GObject *object, gpointer user_data);
    static int PopupCancelCB(GObject *object, gpointer user_data);

    void create_dialog();
    
    GtkWidget* _output_table;
    GtkWidget* _output_label;
    GtkWidget* _output_commandCHKB;
      gboolean _o_cCHKBval;

    GtkWidget* _output_resultsCHKB;
      gboolean _o_rCHKBval;
 
    const gchar* text_buffer_contents;

    GtkWidget* _dialog;
    GtkWidget* _find_dialog;
    GtkWidget* _entry_w;
    GtkWidget* _sep1;
    string _cmd;
};


#endif 
