// 
//  Copyright (C) 2008  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef TASKMONREFDIALOG_HH
#define TASKMONREFDIALOG_HH

#include <stdio.h>
#include <gtk/gtk.h>
#include <iostream>
#include <string>
#include <map>

using namespace std;

class TaskmonRefDialog
{
  public:
    TaskmonRefDialog(string tname, string fname);
    ~TaskmonRefDialog();
    virtual int show();

    int doit(); 
    void clear_entry(); 
    static void cleanup(TaskmonRefDialog *dialog, gint arg1, gpointer user_data);

  protected:
    void generate_form(); 

    GtkWidget* base_w; 
    GtkWidget* _scrolled; 
    GtkWidget* _sheet;
    GtkWidget* _view;
    GtkTextBuffer *_buffer;
    string     _title;             // title of dialog  
    string     _filename;          // name of file to display  
    static  map<string, bool, less<string> > _active;  // active dialog instances 
};

#endif 
