// 
//  Copyright (C) 2007-2008  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef TASKMONTEXTAREA_HH
#define TASKMONTEXTAREA_HH

#include <stdio.h>
#include <gtk/gtk.h>
#include <gtk/gtktextmark.h>
#include <iostream>
#include <string>

#include "TaskmonMessageDialog.hh"

using namespace std;

class TaskmonTextArea
{
  public:
    TaskmonTextArea();
    ~TaskmonTextArea();

  // insert the contents of "msg" into the text buffer
    int add_message(string msg);

  // return the contents of a text buffer
    string get_buffer_contents();

  // get the starting iter of the text buffer
     void get_text_start_iter(GtkTextBuffer *buffer, GtkTextIter *iter); 

  // get the ending iter of the text buffer
     void get_text_end_iter(GtkTextBuffer *buffer, GtkTextIter *iter); 

  // Move the cursor to the search string
     void MoveToString(string searchstring); 

  // Move the cursor to the end of the output buffer
     void MoveToEnd();

    int  set_timestamp(bool val)   { timestamp = val; return 0; } 
    bool get_timestamp()           { return timestamp; } 
    int  set_message_prepend(bool val)  { prepend = val; return 0; }
    bool get_message_prepend()     { return prepend; } 

    int show(); 

    GtkWidget* base_widget()       { return base_w; }


  protected: 
    GtkWidget*     base_w; 
    GtkWidget*     textBox;
    GtkTextBuffer* buffer;
    bool           timestamp; 
    bool           prepend; 

  // iters for use in the FIND capability
    GtkTextIter start_iter, end_iter;
    GtkTextIter matchstart, matchend;

};

#endif 
