// 
//  Copyright (C) 2008  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#include "CiaoTextEntryDialog.hh"

using namespace std;

CiaoTextEntryDialog::CiaoTextEntryDialog(string label)
{
   _label = label;
}

CiaoTextEntryDialog::~CiaoTextEntryDialog()
{
}

void CiaoTextEntryDialog::create_dialog()
{
   _dialog = gtk_dialog_new_with_buttons("Analysis Menu Entry", NULL,
      GTK_DIALOG_DESTROY_WITH_PARENT, GTK_STOCK_OK, GTK_RESPONSE_OK,
      GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL, NULL);
   GtkWidget* tab = gtk_table_new(3,8, true);
   GtkWidget* lab_w = gtk_label_new(_label.c_str()); 
   gtk_container_add(GTK_CONTAINER(GTK_DIALOG(_dialog)->vbox), tab);
   _entry_w = gtk_entry_new(); 
   gtk_table_attach_defaults(GTK_TABLE(tab), lab_w, 1,3,1,2);
   gtk_table_attach_defaults(GTK_TABLE(tab), GTK_WIDGET(_entry_w), 3,7,1,2);
   show(); 
}

int CiaoTextEntryDialog::show()
{
   gtk_widget_show_all(_dialog);
   return 0;
}

int CiaoTextEntryDialog::get_value(string &val)
{
   int resp = 1; 
   create_dialog();
   if (gtk_dialog_run(GTK_DIALOG(_dialog)) == GTK_RESPONSE_OK)
   {
      val = gtk_entry_get_text(GTK_ENTRY(_entry_w));
      resp = 0; 
   }
   gtk_widget_destroy(_dialog);
   return (resp);  
}


